package com.admost.admost_flutter_plugin;

import android.app.Activity;
import android.content.Context;
import android.view.View;
import java.util.HashMap;
import admost.adserver.ads.AdMostBannerAd;
import admost.sdk.AdMostView;
import admost.sdk.base.AdMostLog;
import admost.sdk.listener.AdMostViewListener;
import io.flutter.plugin.common.BinaryMessenger;
import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.platform.PlatformView;

public class AdmostBanner implements PlatformView, MethodChannel.MethodCallHandler  {

    private MethodChannel channel;
    private AdMostView adView;

    public AdmostBanner(Activity activity, BinaryMessenger messenger, int id, HashMap args) {
        AdMostLog.i("adMostBanner id : " + id);

        channel = new MethodChannel(messenger, "admost_flutter/banner_" + id);
        channel.setMethodCallHandler(this);

        int adSize = getSize((HashMap) args.get("adSize"));
        String adUnitId = (String) args.get("adUnitId");

        adView = new AdMostView(activity, adUnitId, adSize, new AdMostViewListener() {
            @Override
            public void onReady(String s, int i, View view) {

            }

            @Override
            public void onFail(int i) {

            }

            @Override
            public void onClick(String s) {

            }
        }, null);
        adView.load();
    }

    private int getSize(HashMap size) {
        String name = (String) size.get("name");
        if (name.equals("BANNER")) {
            return AdMostBannerAd.AD_BANNER;
        } else if (name.equals("MEDIUM_RECTANGLE")) {
            return AdMostBannerAd.AD_MEDIUM_RECTANGLE;
        } else {
            return AdMostBannerAd.AD_LEADERBOARD;
        }
    }

    @Override
    public void onMethodCall(MethodCall methodCall, MethodChannel.Result result) {
        if (methodCall.method.equals("setListener")) {
            adView.setListener(new AdMostViewListener() {
                @Override
                public void onReady(String s, int i, View view) {
                    channel.invokeMethod(AdmostAdEvents.loaded,null);
                }

                @Override
                public void onFail(int i) {
                    channel.invokeMethod(AdmostAdEvents.failedToLoad,null);
                }

                @Override
                public void onClick(String s) {
                    channel.invokeMethod(AdmostAdEvents.clicked,null);
                }
            });
        } else if (methodCall.method.equals("dispose")) {
            adView.destroy();
            channel.setMethodCallHandler(null);
        }
    }

    @Override
    public View getView() {
        return adView.getView();
    }

    @Override
    public void dispose() {
        adView.destroy();
        channel.setMethodCallHandler(null);
    }
}