//
//  AdmostBannerFactory.m
//  admost_flutter_plugin
//
//  Created by Mehmet Karagöz on 9.12.2019.
//

#import "AdmostBannerFactory.h"
#import "AdmostBanner.h"

@implementation AdmostBannerFactory {
    NSObject<FlutterBinaryMessenger> *_messenger;
}

#pragma mark - NSObject

+ (instancetype)bannerFactoryWithMessenger:(NSObject<FlutterBinaryMessenger>*)messenger {
    return [[[self class] alloc] initWithMessenger:messenger];
}

- (instancetype)initWithMessenger:(NSObject<FlutterBinaryMessenger>*)messenger {
    if (!(self = [super init]))
        return nil;
    _messenger = messenger;
    return self;
}

#pragma mark - FlutterPlatformViewFactory

- (NSObject<FlutterPlatformView> *)createWithFrame:(CGRect)frame viewIdentifier:(int64_t)viewId arguments:(id)args {
    return [AdmostBanner bannerWithFrame:frame
                          viewIdentifier:viewId
                               arguments:args
                               messenger:_messenger];
}

- (NSObject<FlutterMessageCodec> *)createArgsCodec {
    return [FlutterStandardMessageCodec sharedInstance];
}

@end
