//
//  AdmostSDKPlugin.m
//  admost_flutter_plugin
//
//  Created by Mehmet Karagöz on 9.12.2019.
//

#import "AdmostSDKPlugin.h"
#import "AdmostBannerFactory.h"
#import <AMRSDK/AMRSDK.h>

@implementation AdmostSDKPlugin

+ (void)registerWithRegistrar:(NSObject<FlutterPluginRegistrar>*)registrar {
    AdmostSDKPlugin *instance = [[AdmostSDKPlugin alloc] init];
    FlutterMethodChannel *defaultChannel = [FlutterMethodChannel methodChannelWithName:@"admost_flutter"
                                                                       binaryMessenger:registrar.messenger];
    [registrar addMethodCallDelegate:instance channel:defaultChannel];
    
    AdmostBannerFactory *bannerFactory = [AdmostBannerFactory bannerFactoryWithMessenger:registrar.messenger];
    [registrar registerViewFactory:bannerFactory
                            withId:@"admost_flutter/banner"];
}

- (void)handleMethodCall:(FlutterMethodCall *)call result:(FlutterResult)result {
    NSString *appId = (NSString *)call.arguments;
    if (!appId) return;
    
    if ([call.method isEqualToString:@"initialize"]) {
        [AMRSDK startWithAppId:appId];
    } else if ([call.method isEqualToString:@"startTestSuite"]) {
        [AMRSDK startTestSuiteWithAppId:appId];
    } else {
        result(FlutterMethodNotImplemented);
    }
}

@end
