import 'package:flutter/services.dart';

class Admost {
  /// Starts Admost mediation and analytics functions, it must be called at the very beginning of the application life cycle
  /// appId : Application id got from Admost dashboard
  Admost.initialize(String appId) {
    MethodChannel _channel = const MethodChannel('admost_flutter');
    _channel.invokeMethod('initialize', appId);
  }

  /// Opens up test screen for ad network testing, available only for testers
  /// To be tester, Google Advertising Id has to be entered in the Admost Dashboard Testers screen
  Admost.startTestSuite() {
    MethodChannel _channel = const MethodChannel('admost_flutter');
    _channel.invokeMethod('startTestSuite');
  }
}
