import 'package:flutter/services.dart';

import 'admost_ad_events.dart';
export 'admost_ad_events.dart';

abstract class AdmostEventHandler {
  final Function(AdmostAdEvent, Map<String, dynamic>) _listener;

  AdmostEventHandler(Function(AdmostAdEvent, Map<String, dynamic>) listener)
      : _listener = listener;

  Future<dynamic> handleEvent(MethodCall call) async {
    switch (call.method) {
      case 'loaded':
        _listener(AdmostAdEvent.loaded, null);
        break;
      case 'failedToLoad':
        _listener(AdmostAdEvent.failedToLoad,
            Map<String, dynamic>.from(call.arguments));
        break;
      case 'clicked':
        _listener(AdmostAdEvent.clicked, null);
        break;
      case 'dismissed':
        _listener(AdmostAdEvent.dismissed, null);
        break;
      case 'completed':
        _listener(AdmostAdEvent.completed, null);
        break;
    }

    return null;
  }
}
